package org.example;

import java.util.*;

public class Map {
    protected String nom;
    protected ArrayList<String> lieu;
    protected int debut;
    protected int fin;
    protected int longueur;
    protected ArrayList<Enemy> listeEnnemisPossibles;
    protected ArrayList<Enemy> listeEnnemis;


    public Map(String nom, ArrayList<String> lieu, ArrayList<Enemy> enemyList) {
        this.nom = nom;
        this.lieu = lieu;
        this.debut = 0;
        this.fin = lieu.size()-1;
        this.longueur = lieu.size();
        this.listeEnnemisPossibles = enemyList;
        this.listeEnnemis = null;
    }

    public void initialiser(){
        ArrayList<Enemy> listeEnnemis = new ArrayList<>() ;
        listeEnnemis.add(null);
        Random random = new Random();
        for (int i = 0; i < this.longueur-2; i++) {
            int ajoutEnnemi = random.nextInt(3);
            if (ajoutEnnemi ==0){
                listeEnnemis.add(null);
            }
            else {
                int choixEnnemi = random.nextInt(this.listeEnnemisPossibles.size());
                listeEnnemis.add(this.listeEnnemisPossibles.get(choixEnnemi));
            }
        }
        int choixEnnemi = random.nextInt(this.listeEnnemisPossibles.size());
        Enemy boss = this.listeEnnemisPossibles.get(choixEnnemi);
        boss.setAttackPower(boss.getAttackPower() * 2);
        boss.setMaxHP(boss.getMaxHP()*2);
        boss.setCurrentHP(boss.getMaxHP());
        listeEnnemis.add(boss);
        this.listeEnnemis = listeEnnemis;
    }
}
