package org.example;

import org.example.BeatThemAllGame.HealthPotion;

public class Test {

    //TO-DO => les tests sont à refaire/améliorer !
    public static void runTests() {
        System.out.println("\n--- Exécution des tests unitaires ---");
        testEnemyDefeated();
        testGameOver();
        testSpecialAbility();
        testItemUsage();
        System.out.println("--- Tous les tests se sont terminés avec succès ---\n");
    }

    public static void testEnemyDefeated() {
        Hero hero = new Hero("TestHero", 100, 50, 0, null);
        Enemy enemy = new Enemy("TestEnemy", 50, 0, 0, null);
        hero.attack(enemy);
        assert enemy.currentHP == 0 : "L'ennemi aurait dû être vaincu.";
    }

    public static void testGameOver() {
        Hero hero = new Hero("TestHero", 0, 0, 0, null);
        assert !hero.isAlive() : "Le héros devrait être mort.";
    }

    public static void testSpecialAbility() {
        Hero hero = new Hero("TestHero", 100, 20, 0, new DoubleAttack());
        Enemy enemy = new Enemy("TestEnemy", 100, 0, 0, null);
        hero.useSpecialAbility(enemy);
        assert enemy.currentHP == 60 : "La capacité spéciale du héros n'a pas fonctionné correctement.";
    }

    public static void testItemUsage() {
        Hero hero = new Hero("TestHero", 100, 20, 0, null);
        hero.currentHP = 50;
        Item potion = new HealthPotion();
        potion.applyEffect(hero);
        assert hero.currentHP == 100 : "La potion de santé n'a pas restauré correctement les PV du héros.";
    }
}
